//
//  Shaders.metal
//  Solar System
//
//  Created by Albert Kwaśkiewicz on 5/4/20.
//  Copyright © 2020 Albert Kwaśkiewicz. All rights reserved.
//

#include <metal_stdlib>
using namespace metal;

#import "Common.h"


struct VertexIn {
    float4 position [[attribute(0)]];
    float3 normal [[attribute(1)]];
    
};

struct VertexOut {
    float4 position [[position]];
    float pointSize [[point_size]];
    float3 normal;
};

vertex VertexOut vertex_main(const VertexIn in [[stage_in]],
                             constant Uniforms &uniforms [[buffer(BufferIndexUniforms)]]) {
    VertexOut out {
        .position = uniforms.projectionMatrix * uniforms.viewMatrix * uniforms.modelMatrix * in.position,
        .pointSize = 3.0,
        .normal = in.normal
    };
    return out;
}

fragment float4 fragment_main(const VertexIn in [[stage_in]]) {
//    return float4(0, 0, 0, 1);
    return float4(in.normal, 0);
}
